#!/usr/bin/perl -w
###############################################################################
#
# Freenet CGI Request Client v0.0.6
#
# Copyright (C) 1999, 2000 Steven Hazel
#
# Edited May 26, 2000 by Lee Benjamin Burhans
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# see http://freenet.sourceforge.net/ for more info on Freenet
#
###############################################################################

use strict;
use keyindex;
use URI::Escape;
use CGI qw(:standard);
use LWP::Simple;

my $FCRC = "http://localhost/cgi-bin/fcrc.pl";
my $INDEXFILE = '';

$keyindex = param('keyindex') || "";
$search = param('search') || "";

my @files = ();
my @dirs = ();
my @lines = ();
my @results = ();
my $junk;
my $line = "";
my $prevline = "";
my $urikey = "";
my $uriline = "";

my $term = "";
my @possibles = ();
my $fail = 0;
my $psearch = "";

my $key = "";
my $pkey = "";

if (defined($ENV{'PATH_INFO'})) {
  $key = $ENV{'PATH_INFO'};
  $key =~ tr/+/ /;
  $key =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $key =~ s/^\/*//;
}
  
$pkey = $key;
$pkey =~ s/\&/\&amp\;/g;
$pkey =~ s/\</\&lt\;/g;
$pkey =~ s/\>/\&gt\;/g;

print "Content-type: text/html\n\n";
print "<HEAD>\n";
print "<TITLE>/$pkey directory</TITLE>\n";
print "</HEAD>\n";
print "<H2>Current directory is /$pkey</H2>\n";
print "<HR>\n";
print "Welcome to Steve's key directory\n";
print "<form ";
print "action=./ ";
print "method=get>\n";
print "keyindex: <input type=textarea name=keyindex><br>\n";
print "search: <input type=textarea name=search><input type=submit>\n";
print "</form>\n";
print "<HR>\n";

if (($INDEXFILE eq "") or ($keyindex ne "")) {
  if ($keyindex eq "") {
    $keyindex = "http://azrael.dyn.cheapnet.net/cgi-bin/keyindex.pl";
  }
  @lines = split(/\n/, get($keyindex));
} else {
  @lines = keyindex::get_keys($INDEXFILE);
}
@lines = sort(@lines);
for $line (@lines) {
  $line =~ s/^\s*//;
  $line =~ s/\s*$//;

  $line =~ s/\&/\&amp\;/g;
  $line =~ s/\</\&lt\;/g;
  $line =~ s/\>/\&gt\;/g;
}

if ($search eq "") {
  for $line (@lines) {
    if ($line =~ m/^\Q$pkey\E/) {
      push(@results, $line);
    }
  }
} else {
  $psearch = $search;
  $psearch =~ s/\&/\&amp\;/g;
  $psearch =~ s/\</\&lt\;/g;
  $psearch =~ s/\>/\&gt\;/g;
  print "Keys matching \"$psearch\":<br><br>\n";
  for $line (@lines) {
    if ($line =~ m/^\Q$pkey\E/) {
      for $term (split(/\s/, $search)) { 
	if ((not ($term =~ m/^\+/))
	    and (not ($term =~ m/^\-/))) {
	  if ($line =~ m/$term/i) {
	    push(@possibles, $line);
	    last;
	  }
	}
      }
    }
  }

  for $line (@possibles) {
    $fail = 0;
    for $term (split(/\s/, $search)) { 
      if ($term =~ m/^\+/) {
	$term =~ s/^\+(.*)/$1/;
	if (not ($line =~ m/$term/i)) {
	  $fail = 1;
	  last;
	}
      } elsif ($term =~ m/^\-/) {
	$term =~ s/^\-(.*)/$1/;
	if ($line =~ m/$term/i) {
	  $fail = 1;
	  last;
	}
      }
    }

    if ($fail == 0) {
      push(@results, $line);
    }
    
  }

}

if  ($key ne "") {
  print "<a href=\"../?search=$search\">Previous Directory</a><br><br>\n";
}


for $line (@results) {
  $line =~ s/^\Q$pkey\E//;

  if (($line =~ m/\//) 
      and (not ($line =~ m/\/\//))          # keys with double slashes
      and (not ($line =~ m/^\//))           # keys that start with a /
      and (not ($line =~ m/\/$/))
      and (not ($line =~ m/^\.+$/))
      and (not ($line =~ m/^\.+\//))
      and (not ($line =~ m/\/\.+$/))
      and (not ($line =~ m/\/\.+\//))) {
    ($line, $junk) = split(/\//, $line);
    push(@dirs, "$line/");
  } else {
    if ((not ($line =~ m/\/\//)) or ($key eq "")) {
      push(@files, $line);
    }
  }
}

@files = sort(@files);
@dirs = sort(@dirs);


$urikey = uri_escape($pkey);

$prevline = "";
for $line (@dirs) {
  if ($line ne $prevline) {
    print "<a href=\"";
    $uriline = uri_escape($line);
    $uriline =~ s/\?/\%3F/g;
    print $uriline;
    if ($keyindex ne "") {
      print "?keyindex=$keyindex";
    }
    if ($search ne "") {
      print "?search=$search";
    }
    print "\"><tt>$line</tt></a><br>\n";
    $prevline = $line;
  }
}

$prevline = "";
for $line (@files) {
  if ($line ne $prevline) {
    print "<a href=\"$FCRC/";
    if (($line =~ m/^\.+$/) or     # keys that are just .s
	($line =~ m/^\.+\//) or    # keys that begin with .s and a slash
	($line =~ m/\/\.+$/) or    # keys that end with a slash and some .s
	($line =~ m/\/\.+\//)) {   # keys with .s between slashes
      print "?key=";
    }
    if ($key ne "") {
      print "$urikey";
    }
    $uriline = uri_escape($line);
    $uriline =~ s/\?/\%3F/g;       # escape ?s
    $uriline =~ s/^\//.\/\//;      # replace .// with /
    print $uriline;
    if ($keyindex ne "") {
      print "?keyindex=$keyindex";
    }
    print "\"><tt>$line</tt></a><br>\n";
    $prevline = $line;
  }
}
